﻿------------------------------------------------------------------------------------------
--Frame Control Functions-----------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))

function SN:UnlockFrame(frame)
	local SNd = SN.data.profile
	if frame == nil then return end

	if SNd.Frames.lock and frame ~= nil then
		if frame == F.powermover then
			F.powercontainer:Hide()
		end
		if frame == F.classpower then
			if F.classpower.frame ~= nil then
				F.classpower.frame:Hide()
			end
		end
		
		frame:SetBackdrop( { bgFile   = "Interface/Tooltips/UI-Tooltip-Background",
							edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
							tile     = false,
							tileSize = 0,
							edgeSize = 2,
							insets = { left = 0, right = 0, top = 0, bottom = 0 }
						} )
		frame:SetBackdropColor(.1, .1, .1, .8)
		frame:SetBackdropBorderColor(.1, .1, .1, .5)
			
		frame.value:SetText(frame.name)
			
		--frame.t = frame:CreateTexture("ARTWORK")
		--frame.t:SetPoint("TOPLEFT", frame, "TOPLEFT", 1, -1)
		--frame.t:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -1, -19)
		--frame.t:SetHeight(20)
		--frame.t:SetTexture(.5, .5, .5)
		--frame.t:SetAlpha(.3)

		frame.d = frame:CreateTexture("ARTWORK")
		frame.d:SetHeight(16)
		frame.d:SetWidth(16)
		frame.d:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -1, 1)
		frame.d:SetTexture(M.media.draghandle)
		frame.d:SetAlpha(.3)

		frame.tr = frame:CreateTitleRegion()
		frame.tr:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, 0)
		frame.tr:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, 0)
		frame.tr:SetHeight(21)

		frame:EnableMouse(true)
		frame:SetMovable(true)
		frame:RegisterForDrag("LeftButton")
	end
end

function SN:LockFrame(frame)
	local SNd = SN.data.profile
	local v = {}
	if frame == nil then return end

	if frame == F.powercontainer then
		v = SNd.Frames.power
	elseif frame == F.classpower then
		v = SNd.Frames.classpower
	end
	if frame == F.powermover then
		if SNd.powerbar.enable then
			if select(2, UnitPowerType("player")) == "RAGE" or select(2, UnitPowerType("player")) == "ENERGY" or
					select(2, UnitPowerType("player")) == "FOCUS" or 
						select(2, UnitPowerType("player")) == "RUNIC_POWER" then
						
				F.powercontainer:Show()
			end
		end
	end
	if frame == F.classpower then
		if F.classpower.frame ~= nil then
			F.classpower.frame:Show()
		end
	end
	if not SN.data.profile.Frames.lock and frame ~= nil then
		frame:SetBackdrop(nil)
		--frame.t:Hide()
		--frame.t = nil
		frame.d:Hide()
		frame.d = nil
		frame.tr = nil
		frame.value:SetText("")
		frame:EnableMouse(false)
		frame:SetMovable(false)
		
		v[1], v[2], v[3], v[4], v[5] = frame:GetPoint()

		--sweep up
		collectgarbage("collect")

	end
end

function SN:MoveFrames(settings)
	local frames = { F.powermover, F.classpower, F.dispel }
	
	if settings then
		if frames[1] and F.powermover:IsShown() then
			SN:LockFrame(frames[1])
		end
		if frames[2] and F.classpower:IsShown() then
			SN:LockFrame(frames[2])
		end
		SN:LockFrame(frames[3])
		F.cooldowns:Lock(settings)
		F.debuffs:Lock(settings)
		SN.data.profile.Frames.lock = true
	else
		if frames[1] and F.powermover:IsShown() then
			SN:UnlockFrame(frames[1])
		end
		if frames[2] and F.classpower:IsShown() then
			SN:UnlockFrame(frames[2])
		end
		SN:UnlockFrame(frames[3])
		F.cooldowns:Lock(settings)
		F.debuffs:Lock(settings)
		SN.data.profile.Frames.lock = false
	end
end



function ResetAnchors()
	local static = SN.DB.defaults.profile.Frames
	local temp = SN.data.profile.Frames
	local frames = { F.powermover, F.classpower, F.cooldowns, F.dispel }

	for i, frame in pairs(frames) do
		if frame then
			frame:ClearAllPoints()
		end
	end

	if (IsAddOnLoaded("ElvUI")) then
		F.cooldowns:SetPoint(unpack(static.elvcooldowns))
		wipe(temp.elvcooldowns)
	else
		F.cooldowns:SetPoint(unpack(static.cooldowns))
		wipe(temp.cooldowns)
	end
	if not F.powermover then
		F.powermover:SetPoint(unpack(static.power))
	end
	if not F.classpower then
		F.classpower:SetPoint(unpack(static.classpower))
	end
	if not F.dispel then
		F.dispel:SetPoint(unpack(static.dispel))
	end
	wipe(temp.dispel)
	wipe(temp.power)
	wipe(temp.classpower)
	ReloadUI()
end